'''
    REVERSIBLE

    Write a decorator reversible, that decorates a function f to accept
    the keyword argument 'reverse'. Default is reverse=False.
    If reverse=True the output of the function should be returned in
    reverse order.

    The function f should be able to take both positional and keyword
    arguments, and it is assumed f returns a sliceable object (like lists,
    tuples and strings). 

    Input:  Multiple lines of Python code using the decorator reversible.
            The last line should start with '#eof' (indicating end of file).

    Output: The output generated by executing the input code.

    Example:

      Input:  @reversible
              def powers(L, power):
                  return [e ** power for e in L]

              print(powers(range(6), 3))
              print(powers(range(6), 3, reverse=True))
              #eof

      Output: [0, 1, 8, 27, 64, 125]
              [125, 64, 27, 8, 1, 0]

    Note: The below code already handles reading and executing the input.
'''


# insert code
def reversible(f):
    pass
#> solution
    def wrapper(*args, reverse=False, **kwargs):
        result = f(*args, **kwargs)
        return result[::-1] if reverse else result

    return wrapper
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate

exec(code)
